package cpcns.dingZhi.impAndexpUtil.dao.impl;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.base.common.User;
import cpcns.base.configuration.AppConfiguration;
import cpcns.dangAnBase.base.dao.impl.DangAnBaseDaoImpl;
import cpcns.dingZhi.impAndexpUtil.dao.ExpDao;
import cpcns.utils.FtpConfig;
import cpcns.utils.FtpUtil;
import java.io.IOException;
import java.net.SocketException;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.apache.commons.lang.StringUtils;
import org.hibernate.SQLQuery;
import org.hibernate.criterion.CriteriaSpecification;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Repository;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

@Repository("expDao")
public class ExpDaoImpl extends DangAnBaseDaoImpl implements ExpDao {
  private Logger logger = LoggerFactory.getLogger(getClass());
  
  public int getCountSql(String sql) {
    SQLQuery query = getSession().createSQLQuery(sql);
    List list = query.list();
    return Integer.parseInt(query.list().get(0));
  }
  
  public List getListHqlpoge(String sql) {
    SQLQuery query = getSession().createSQLQuery(sql);
    query.setResultTransformer(CriteriaSpecification.ALIAS_TO_ENTITY_MAP);
    List list = query.list();
    return list;
  }
  
  public boolean fujian(Object object, String table) {
    System.out.println("请确认数据库里是否有" + table + "fujian这个表！！！！！！！！！！！");
    table = table.toUpperCase();
    if ("MYSQL".equals(getDataType())) {
      try {
        String str = "SELECT 1 FROM " + table + "fujian LIMIT 1";
        getSession().createSQLQuery(str).list();
      } catch (Exception e) {
        System.out.println("现在是mysql 数据库！系统判定你现在连接的数据库没有" + table + "fujian 表。");
        return false;
      } 
    } else {
      String isnotTable = "SELECT COUNT(*) FROM user_tables WHERE table_name = '" + table + "FUJIAN'";
      SQLQuery query = getSession().createSQLQuery(isnotTable);
      List<String> list = query.list();
      if ("0".equals(query.list().get(0).toString())) {
        System.out.println("现在是oracle 数据库！系统判定你现在连接的数据库没有" + table + "fujian 表。");
        return false;
      } 
    } 
    String sql = "select COUNT(*) from " + table + "FuJian where guanLianBiaoShi = " + object;
    SQLQuery query2 = getSession().createSQLQuery(sql);
    if (Integer.parseInt(query2.list().get(0).toString()) > 0)
      return true; 
    return false;
  }
  
  public Boolean fileDownload(String quanZongHao, String dirPath, String fileName, String localFilePath, String localFileName) {
    Boolean result = Boolean.valueOf(true);
    FtpConfig config = getFtpInfo(quanZongHao);
    FtpUtil ftpUtil = new FtpUtil();
    try {
      ftpUtil.connectServer(config);
      this.logger.info("连接FTP成功[" + config.getServer() + "]");
      result = Boolean.valueOf(ftpUtil.changeDirectory(dirPath));
      if (!result.booleanValue()) {
        this.logger.error("FTP进入目录失败[" + dirPath + "]");
        return result = Boolean.valueOf(false);
      } 
      this.logger.info("FTP文件下载，已切换到当前路径为[" + ftpUtil.ftpClient.printWorkingDirectory() + "]");
      result = Boolean.valueOf(ftpUtil.download(new String(fileName.getBytes("UTF-8"), "iso-8859-1"), localFilePath, localFileName));
      ftpUtil.closeServer();
    } catch (SocketException e) {
      e.printStackTrace();
      result = Boolean.valueOf(false);
    } catch (IOException e) {
      e.printStackTrace();
      result = Boolean.valueOf(false);
    } 
    return result;
  }
  
  public String getFtpQuanZong() {
    HttpSession session = getRequest().getSession();
    User user = (User)session.getAttribute("cpcns.sso.client.filter.user");
    String ftpQuanZongHao = AppConfiguration.getConfigValue("CPCNS_QUANZHONGHAO");
    if (StringUtils.isBlank(ftpQuanZongHao))
      ftpQuanZongHao = "DA145"; 
    String xtlx = AppConfiguration.getConfigValue("CPCNS_XITONGLEIXING");
    if ("1".equals(xtlx))
      ftpQuanZongHao = user.getQuanZongHao(); 
    return ftpQuanZongHao;
  }
  
  public static HttpServletRequest getRequest() {
    return ((ServletRequestAttributes)RequestContextHolder.getRequestAttributes()).getRequest();
  }
}
